{
Demonstrator of TODPriceController component

Copyright (c) 1998.  All rights reserved.
Orbital Decisions (Pty) Ltd
PO Boc 1080, Milnerton, 7435, South Africa
sales@orbital.co.za
http://wwww.orbital.co.za/contents.htm

This demo project maintains a price history table for the DBDEMOS
Parts.db table. The prices are kept in a seperate Prices.db table
provided with this demo (in the same directory).
You can use this form as a template for your own price maintenace screens.
}
unit DemoUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, ODPrCtrl, Grids, DBGrids, ComCtrls, StdCtrls, ExtCtrls,
  DBCtrls;

type
  TDemoForm = class(TForm)
    Parts: TTable;
    PartsSource: TDataSource;
    PartsGrid: TDBGrid;
    PartsDescription: TStringField;
    PricesGrid: TDBGrid;
    Prices: TTable;
    PricesFirstDate: TDateField;
    PricesLastDate: TDateField;
    PricesPrice: TCurrencyField;
    AddPriceButton: TButton;
    PriceEdit: TEdit;
    Label1: TLabel;
    StartDateEdit: TDateTimePicker;
    Label2: TLabel;
    Label3: TLabel;
    PricesSource: TDataSource;
    PartsPartNo: TFloatField;
    PricesPartNo: TFloatField;
    PriceController: TODPriceController;
    VerifyPricesButton: TButton;
    DBNavigator1: TDBNavigator;
    procedure AddPriceButtonClick(Sender: TObject);
    procedure PriceEditChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure VerifyPricesButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DemoForm: TDemoForm;

implementation

{$R *.DFM}

procedure TDemoForm.FormShow(Sender: TObject);
begin
  Parts.Open;
  Prices.Open;
  StartDateEdit.Date := Date;
end;

procedure TDemoForm.PriceEditChange(Sender: TObject);
begin
  AddPriceButton.Enabled := PriceEdit.Text <> '';
end;

procedure TDemoForm.AddPriceButtonClick(Sender: TObject);
begin
  PriceController.AddPrice(StartDateEdit.Date, StrToFloat(PriceEdit.Text));
  Prices.Refresh;
  PriceEdit.Text := '';
end;

procedure TDemoForm.VerifyPricesButtonClick(Sender: TObject);
begin
  PriceController.VerifyDates;
end;

end.
